diff --git a/lib/csv.rb b/lib/csv.rb
index ac77af7..2d7c6ad 100644
--- a/lib/csv.rb
+++ b/lib/csv.rb
@@ -1017,6 +1017,7 @@ class MalformedCSVError < RuntimeError; end
   # <b><tt>:skip_blanks</tt></b>::        +false+
   # <b><tt>:force_quotes</tt></b>::       +false+
   # <b><tt>:skip_lines</tt></b>::         +nil+
+  # <b><tt>:liberal_parsing</tt></b>::    +false+
   #
   DEFAULT_OPTIONS = { col_sep:            ",",
                       row_sep:            :auto,
@@ -1029,7 +1030,8 @@ class MalformedCSVError < RuntimeError; end
                       header_converters:  nil,
                       skip_blanks:        false,
                       force_quotes:       false,
-                      skip_lines:         nil }.freeze
+                      skip_lines:         nil,
+                      liberal_parsing:    false }.freeze
 
   #
   # This method will return a CSV instance, just like CSV::new(), but the
@@ -1495,6 +1497,10 @@ def self.table(path, options = Hash.new)
   #                                       a comment. If the passed object does
   #                                       not respond to <tt>match</tt>,
   #                                       <tt>ArgumentError</tt> is thrown.
+  # <b><tt>:liberal_parsing</tt></b>::    When set to a +true+ value, CSV will
+  #                                       attempt to parse input not conformant
+  #                                       with RFC 4180, such as double quotes
+  #                                       in unquoted fields.
   #
   # See CSV::DEFAULT_OPTIONS for the default settings.
   #
@@ -1618,6 +1624,8 @@ def header_converters
   def skip_blanks?()        @skip_blanks        end
   # Returns +true+ if all output fields are quoted. See CSV::new for details.
   def force_quotes?()       @force_quotes       end
+  # Returns +true+ if illegal input is handled. See CSV::new for details.
+  def liberal_parsing?()    @liberal_parsing    end
 
   #
   # The Encoding CSV is parsing or writing in.  This will be the Encoding you
@@ -1855,20 +1863,27 @@ def shift
             csv.last << @col_sep
           end
         elsif part[0] == @quote_char
-          # If we are staring a new quoted column
-          if part[-1] != @quote_char || part.count(@quote_char) % 2 != 0
+          # If we are starting a new quoted column
+          if part.count(@quote_char) % 2 == 0
+            if part[-1] == @quote_char
+              # regular quoted column
+              csv << part[1..-2]
+              if csv.last =~ @parsers[:stray_quote]
+                raise MalformedCSVError,
+                      "Missing or stray quote in line #{lineno + 1}"
+              end
+              csv.last.gsub!(@quote_char * 2, @quote_char)
+            elsif @liberal_parsing
+              csv << part
+            else
+              raise MalformedCSVError,
+                    "Missing or stray quote in line #{lineno + 1}"
+            end
+          else
             # start an extended column
             csv             << part[1..-1]
             csv.last        << @col_sep
             in_extended_col =  true
-          else
-            # regular quoted column
-            csv << part[1..-2]
-            if csv.last =~ @parsers[:stray_quote]
-              raise MalformedCSVError,
-                    "Missing or stray quote in line #{lineno + 1}"
-            end
-            csv.last.gsub!(@quote_char * 2, @quote_char)
           end
         elsif part =~ @parsers[:quote_or_nl]
           # Unquoted field with bad characters.
@@ -1876,7 +1891,11 @@ def shift
             raise MalformedCSVError, "Unquoted fields do not allow " +
                                      "\\r or \\n (line #{lineno + 1})."
           else
-            raise MalformedCSVError, "Illegal quoting in line #{lineno + 1}."
+            if @liberal_parsing
+              csv << part
+            else
+              raise MalformedCSVError, "Illegal quoting in line #{lineno + 1}."
+            end
           end
         else
           # Regular ole unquoted field.
@@ -1941,7 +1960,7 @@ def inspect
     str << " encoding:" << @encoding.name
     # show other attributes
     %w[ lineno     col_sep     row_sep
-        quote_char skip_blanks ].each do |attr_name|
+        quote_char skip_blanks liberal_parsing ].each do |attr_name|
       if a = instance_variable_get("@#{attr_name}")
         str << " " << attr_name << ":" << a.inspect
       end
@@ -2075,6 +2094,7 @@ def init_parsers(options)
     # store the parser behaviors
     @skip_blanks      = options.delete(:skip_blanks)
     @field_size_limit = options.delete(:field_size_limit)
+    @liberal_parsing  = options.delete(:liberal_parsing)
 
     # prebuild Regexps for faster parsing
     esc_row_sep = escape_re(@row_sep)
diff --git a/test/csv/test_features.rb b/test/csv/test_features.rb
index 37fdab8..a558875 100755
--- a/test/csv/test_features.rb
+++ b/test/csv/test_features.rb
@@ -142,6 +142,29 @@ def test_skip_blanks
     assert_equal(3, count)
   end
 
+  def test_liberal_parsing
+    input = '"Johnson, Dwayne",Dwayne "The Rock" Johnson'
+    assert_raise(CSV::MalformedCSVError) do
+        CSV.parse_line(input)
+    end
+    assert_equal(["Johnson, Dwayne", 'Dwayne "The Rock" Johnson'],
+                 CSV.parse_line(input, liberal_parsing: true))
+
+    input = '"quoted" field'
+    assert_raise(CSV::MalformedCSVError) do
+        CSV.parse_line(input)
+    end
+    assert_equal(['"quoted" field'],
+                 CSV.parse_line(input, liberal_parsing: true))
+
+    assert_raise(CSV::MalformedCSVError) do
+      CSV.parse_line('is,this "three," or four,fields', liberal_parsing: true)
+    end
+
+    assert_equal(["is", 'this "three', ' or four"', "fields"],
+      CSV.parse_line('is,this "three, or four",fields', liberal_parsing: true))
+  end
+
   def test_csv_behavior_readers
     %w[ unconverted_fields return_headers write_headers
         skip_blanks        force_quotes ].each do |behavior|